<template>
  <div class="column full-width bg-accent shadow-1 q-pa-md rounded-borders">
    <span class="text-h4 text-center">Cylinder details</span>
    <q-separator class="q-my-md"/>
    <div class="column q-gutter-md q-ml-sm">
      <div v-if="!request">
        <!-- <q-icon name="account" style="font-size: 32px"/> -->
        <span :class="chooseTextClass()">
          <q-icon name="mdi-account"/>
          {{ name }}
        </span>
      </div>

      <div>
        <span :class="chooseTextClass()">
          <q-icon name="mdi-gas-cylinder"/>
          {{ quantity }} Litres
        </span>
        <span :class="chooseTextClass()">{{ type }}-type, </span>
        <span :class="chooseTextClass()">{{ condition }} cylinder available</span>
      </div>

      <div>
        <span :class="chooseTextClass()">
          <q-icon name="mdi-map-marker"/>
          {{ city }}, {{ state }} - {{ pincode }}
        </span>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from '@vue/composition-api'
export default defineComponent({
  name: 'ComponentsCylinderDetails',

  data () {
    return {
      pincode: '',
      state: '',
      city: '',
      type: '',
      condition: '',
      quantity: '',
      name: ''
    }
  },

  computed: {
    cylinderID () {
      return this.$route.params.id
    }
  },

  props: {
    // cylinderID: {
    //   type: String,
    //   required: true
    // },

    request: {
      type: Boolean,
      default: false
    }
  },

  mounted () {
    this.retrieveCylinderData()
  },

  methods: {
    chooseTextClass: function () {
      if (this.$q.screen.lt.sm) {
        return 'text-h6'
      } else {
        return 'text-h4'
      }
    },

    retrieveCylinderData: function () {
      this.getCylinderData()
        .then((response: {data: {
          pincode: string,
          state: string,
          city: string,
          // eslint-disable-next-line camelcase
          cylinder_type: string,
          condition: string,
          quantity: string,
          // eslint-disable-next-line camelcase
          owner_name: string
        }}) => {
          this.pincode = response.data.pincode
          this.state = response.data.state
          this.city = response.data.city
          this.type = response.data.cylinder_type
          this.condition = response.data.condition
          this.quantity = response.data.quantity
          this.name = response.data.owner_name
        })
        .catch((error) => {
          console.log(error)
        })
    },

    getCylinderData: function () {
      return this.$axios.get(`/api/cylinders/${this.cylinderID}`)
    }
  }
})
</script>
